/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = {
	"code": "class HAUSTIER {\n    String name;\n    byte alter;\n    \n    String printInfos() {\n        print(this.name + \" ist \");\n        println(this.alter + \" Jahre alt.\");\n    }\n}\n\nclass KATZE extends HAUSTIER {\n    byte leben;\n    \n    KATZE() {\n        this.leben = 7;\n    }\n}\n\nKATZE Kitty = new KATZE();",
	"classes": [
		{
			"className": "HAUSTIER",
			"atts": [
				{
					"key": "name",
					"type": "String",
					"value": ""
				},
				{
					"key": "alter",
					"type": "byte",
					"value": 0
				}
			],
			"abstract": true
		},
		{
			"className": "KATZE",
			"atts": [
				{
					"key": "name",
					"type": "String",
					"value": ""
				},
				{
					"key": "alter",
					"type": "byte",
					"value": 0
				},
				{
					"key": "leben",
					"type": "byte",
					"value": 0
				}
			],
			"abstract": true,
			"isa": [
				"HAUSTIER"
			]
		}
	],
	"notSelectable": [
		3,
		7,
		8,
		9,
		12,
		15,
		16,
		17
	],
	"methodCalls": [
		4,
		13
	],
	"classDeclarations": [
		{
			"line": 0,
			"className": "HAUSTIER"
		},
		{
			"line": 10,
			"className": "KATZE"
		}
	],
	"steps": [
		{
			"line": -1,
			"vars": {
				"instances": [],
				"vars": [],
				"scopes": []
			},
			"enableTextOut": true,
			"task": "Hier lernst du, wie Objekte einer Klasse erzeugt werden, wenn die Klasse von einer Elternklasse erbt. Du siehst zwei Klassendefintionen und eine Variablendeklaration mit Wertezuweisung und Objekterzeugung. Wähle die letzte Zeile aus, um zu starten."
		},
		{
			"task": "Es geht wie gewohnt los: Erzeuge die Variable und klicke dann bei der richtigen Klassendefintion auf „Erzeugen“.",
			"line": 18,
			"vars": []
		},
		{
			"task": "Weil die Klasse <code>KATZE</code> von der Klasse <code>HAUSTIER</code> erbt, musst du zuerst ein Objekt der Klasse <code>HAUSTIER</code> erzeugen. Klicke also bei dieser Klasse auf „Erzeugen“.",
			"line": 10,
			"vars": [
				{
					"key": "Kitty",
					"type": "KATZE",
					"ref": null
				}
			]
		},
		{
			"task": "Arbeite nun alle Attributdeklarationen der Elternklasse ab.",
			"line": 0,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "Kitty",
						"type": "KATZE",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "KATZE",
						"line": 18,
						"vars": []
					}
				]
			}
		},
		{
			"line": 1,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "Kitty",
						"type": "KATZE",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "KATZE",
						"line": 18,
						"vars": []
					},
					{
						"className": "HAUSTIER",
						"line": 10,
						"vars": []
					}
				]
			}
		},
		{
			"task": "Nachdem du noch dieses Attribut angelegt hast, ist das Erzeugen eines Objektes der Klasse <code>HAUSTIER</code> fertig. Klicke daher in der Speichertabelle auf das Speichern-Symbol. Dadurch springst du automatisch zurück in die Klassendefinition von <code>KATZE</code>. Arbeite nun die Attributdefinitionen dieser Klasse ab.",
			"line": 2,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "Kitty",
						"type": "KATZE",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "KATZE",
						"line": 18,
						"vars": []
					},
					{
						"className": "HAUSTIER",
						"line": 10,
						"vars": [
							{
								"key": "name",
								"type": "String",
								"value": ""
							}
						]
					}
				]
			}
		},
		{
			"task": "Vergiss nicht, nach dem anlegen des letzten Attributs den Konstruktor aufzurufen.",
			"line": 11,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "Kitty",
						"type": "KATZE",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "KATZE",
						"line": 18,
						"vars": [
							{
								"key": "name",
								"type": "String",
								"value": ""
							},
							{
								"key": "alter",
								"type": "byte",
								"value": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "Der Konstruktor wird wie jede Methode abgearbeitet. Da dieser Konstruktor keine Parameter hat, brauchst du nur den Wert von <code>this</code> richtig setzen, bevor du die innere Sequenz abarbeitest.",
			"line": 13,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "Kitty",
						"type": "KATZE",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "KATZE",
						"line": 18,
						"vars": [
							{
								"key": "name",
								"type": "String",
								"value": ""
							},
							{
								"key": "alter",
								"type": "byte",
								"value": 0
							},
							{
								"key": "leben",
								"type": "byte",
								"value": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "Nachdem du diese Wertezuweisung ausgeführt hast, ist die Objekterzeugung endgültig abgeschlossen. Weise nun noch <code>Kitty</code> den richtigen Wert zu.",
			"line": 14,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "KATZE",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": ""
							},
							{
								"key": "alter",
								"type": "byte",
								"value": 0
							},
							{
								"key": "leben",
								"type": "byte",
								"value": 0
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Kitty",
						"type": "KATZE",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 18,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"line": "end",
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "KATZE",
						"atts": [
							{
								"key": "name",
								"type": "String",
								"value": ""
							},
							{
								"key": "alter",
								"type": "byte",
								"value": 0
							},
							{
								"key": "leben",
								"type": "byte",
								"value": 7
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Kitty",
						"type": "KATZE",
						"ref": 0
					}
				],
				"scopes": []
			}
		}
	]
};